package com.example.catchTheLetters.service.impl;

import com.example.catchTheLetters.entity.Level;
import com.example.catchTheLetters.entity.ScoreInfo;
import com.example.catchTheLetters.service.LevelService;
import com.example.catchTheLetters.utils.R;
import jakarta.annotation.Resource;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author 慕华
 * @date 2024/4/10
 * @Version 1.0
 * @description
 */
@Service
public class LevelServiceImpl implements LevelService {

    @Resource
    private MongoTemplate mongoTemplate;

    @Override
    public R<Level> levelDetail(Long id) {
        Level level = mongoTemplate.findOne(new Query(Criteria.where("id").is(id)), Level.class);
        if (level == null){
            return R.fail("查询失败，请重试");
        }
        return R.ok(level);
    }

    @Override
    public R<List<Level>> list() {
        Query query = new Query();
        query.fields().include("id").include("name").include("type");
        List<Level> levels = mongoTemplate.find(query, Level.class);
        return R.ok(levels);
    }

    @Override
    public Integer getRankInfo(String levelId) {
      ScoreInfo sc=mongoTemplate.findById(2,ScoreInfo.class);
      Integer infor = null;
      if(sc!=null) {
          infor  = sc.getScore();
      }
      return  infor;

    }

    @Override
    public boolean LevelCreate(Level level) {
        String s=level.toString();
        if (s != null) {

            mongoTemplate.insert(s);
            return true;
        }

        return false;
    }

}
